#include <stdlib.h>
#include <vga.h>
#include <vgagl.h>
#include "spec.h"
#include "specrgb.h"


#define MODE G320x200x256
#define CLEAR() gl_fillbox(0,0,WIDTH,HEIGHT,0)
#define	BOX_X		50
#define	BOX_Y		40
#define	BOX_W		201
#define	BOX_H		64
#define	BOX_M		(BOX_Y+(BOX_H>>1))
#define	BOX_X2		(BOX_X+BOX_W)


void drawDotSpec( short *samples, int length, int inc )
{
	int i,sample,y;
	
	for ( i=1; i<=length; i++ ){
		sample = *(samples); samples+=inc;
		y = sample*32/32768;
		gl_setpixel( BOX_X+i , BOX_Y+(BOX_H/2)+y, abs(y)+64 );
	}
}

void drawLineSpec( short *samples, int length, int inc )
{
	int i,sample,y;
	
	for ( i=1; i<=length; i++ ){
		sample = *(samples); samples+=inc;
		y = sample*32/32768;
		gl_line( BOX_X+i , BOX_M+y, BOX_X+i, BOX_M, abs(y)+64 );
	}
}


void DoSpectrumDraw( svga_info *si, short *samples, int len, int inc )
{
	if ( si->svgainit ){
		//vga_waitretrace();

		gl_line( BOX_X-2, BOX_M, BOX_X, BOX_M, 20 );
		gl_line( BOX_X2, BOX_M, BOX_X2+2, BOX_M, 20 );
		gl_line( BOX_X, BOX_Y, BOX_X+BOX_W, BOX_Y, 50 );
		gl_line( BOX_X, BOX_Y, BOX_X, BOX_Y+BOX_H, 45 );
		gl_line( BOX_X, BOX_Y+BOX_H, BOX_X+BOX_W, BOX_Y+BOX_H, 30 );
		gl_line( BOX_X+BOX_W, BOX_Y, BOX_X+BOX_W, BOX_Y+BOX_H, 30 );


		switch( si->drawstyle ){
			default:
			case 1:		drawDotSpec( samples, len, inc ); break;
			case 2:		drawLineSpec( samples, len, inc ); break;
		}
			
		gl_copyscreen(&si->screen);
		CLEAR();
	}
}



void InitSpectrum( svga_info *si )
{
  vga_setmode(MODE);
  gl_setcontextvga(MODE); gl_getcontext(&si->screen);
  gl_setcontextvgavirtual(MODE); gl_getcontext(&si->buffer);
    {
      int i;
      for(i=0;i<64;i++)  {
        gl_setpalettecolor(i,i,i,i);
        gl_setpalettecolor(i+64,  srgb[i].r, srgb[i].g, srgb[i].b);
        gl_setpalettecolor(i+128, 0,i,0);
        gl_setpalettecolor(i+192, i,0,i);
      }
    }
 si->svgainit = 1;
}
  
void EndSpectrum( svga_info *si )
{
  if ( si->svgainit )
   vga_setmode(TEXT);
}
